--[[
    Aaron MacDonald
    November 27, 2010
]]

--require('gfx')

colourCycle = {}

function colourCycle.createCycle(colourList, speed, startIndex,
  startAlpha)
    return {colours = colourList, index = startIndex or 0,
      alpha = startAlpha or 0, speed = speed}
end

function colourCycle.update(cycle)
    cycle.alpha = cycle.alpha + cycle.speed
    if cycle.alpha >= 1 then
        cycle.index = (cycle.index + 1) % #cycle.colours
        cycle.alpha = cycle.alpha - 1
    end
end

function colourCycle.setColour(cycle)
    local colourA = cycle.colours[cycle.index + 1]
    local colourB = cycle.colours[
      ((cycle.index + 1) % #cycle.colours) + 1]

    local finalColour = gfx.interpolatedColour(colourB,
      colourA, cycle.alpha)

    love.graphics.setColor(finalColour[1], finalColour[2],
      finalColour[3])
end